/*********************************************************************************
Copyright(c) 2019 Analog Devices, Inc. All Rights Reserved.
This software is proprietary and confidential. By using this software you agree
to the terms of the associated Analog Devices License Agreement.
*********************************************************************************/

/*!
 * @file      main.h
 * @brief     Example to demonstrate LED blink in ADSP-21569 EZ-kit
 * @version:  $Revision: 37413 $
 * @date:     $Date: 2019-04-17 00:56:08 -0400 (Wed, 17 Apr 2019) $
 *
 * @details
 *            This is the primary include file to demonstrate
 *            LED 7/8/10 toggling in ADSP-21569 EZ-kit
 *
 */

#ifndef __MAIN_H__
#define __MAIN_H__

/*=============  I N C L U D E S   =============*/
#include <sys/platform.h>
#include "adi_initialize.h"
#include "sru.h"
#include <services/gpio/adi_gpio.h>
#include <stdio.h>


#define GPIO_MEMORY_SIZE (ADI_GPIO_CALLBACK_MEM_SIZE*2)
static uint8_t gpioMemory[GPIO_MEMORY_SIZE];
int Result;

#endif /* __MAIN_H__ */
