#!python
import serial
import io
import time

#_BOOT_FILE_NAME = "blp_signed_bootstream_binary_with_fill.ldr"
#_BOOT_FILE_NAME = "blx_signed_bootstream_binary_with_fill.ldr"
#_BOOT_FILE_NAME = "blw_signed_bootstream_binary_with_fill.ldr"
_BOOT_FILE_NAME = "BLp_UARTSLAVE.ldr"
#_BOOT_FILE_NAME = "blx_signed_bootstream_binary_without_fill.ldr"
#_BOOT_FILE_NAME = "blw_signed_bootstream_binary_without_fill.ldr"
#_BOOT_FILE_NAME = "LED_UART_Binary_with_Fill.ldr"
#_BOOT_FILE_NAME = "LED_UART_Binary_without_Fill.ldr"

ser = serial.Serial()
ser.baudrate = 57600
ser.parity = serial.PARITY_NONE
ser.stopbits = serial.STOPBITS_ONE
ser.xonoff = False
ser.rtscts = True
ser.port = 24

#ser.timeout = 5
print ser
ser.open()


def read_newline():
    ''' Used to read a string of text from the UART that is terminated with a new line'''
    #print "Number of chars remaining in in buffer: %d" %(ser.inWaiting())
    byte = ser.read(1)
    message = byte
    i=0
    #print "%d: %s" %(i, ord(byte))
    #while byte != "\r":
    while True:
        #print "%d: %s" %(i, ord(byte))
        byte = ser.read(1)
        if byte == "\r":
            break;
        else:
            message += byte
            i+=1
    #ser.flushInput()
    #print "Number of chars remaining in in buffer: %d" %(ser.inWaiting())
    print message 


def boot_processor(fileName):
	''' This will boot a loader file over the UART, the loader file must be in binary format'''
	import sys

	boot_kernel_sync() # perform the initial autobaud detection phase
	write_binary_file_to_uart(fileName)
	send_extra_bytes()
	print "Boot stream transmission completed ... "

def delay_loop(count):
    for i in range(0, count):
        i+=1

def write_binary_file_to_uart(fileName):
    import sys
    count = 1
    # Open the loader file, read each byte and send it to the uart until we reach the end of the file
    with open(fileName, "rb") as f:
        byte = f.read(1)
        while byte != "":
            # Do stuff with byte.
            
            if(count%10 == 0):
                sys.stdout.write(".")
            #sys.stdout.write('0x%.2X count = %s\n' %(ord(byte), count))
            ser.write(byte)
            #sys.stdout.write('Byte transferred')

            waitcount = 0
            while ser.getCTS() == False:
                waitcount +=1
                if(waitcount%100000 == 0):
                    print "waiting"

            byte = f.read(1)
            count +=1
        sys.stdout.write("\nsent %s bytes overall\n" %count)

def send_extra_bytes():
	import sys
	count = 0
	byte = 'AB'
	for count in range(0, 1024):
		# Do stuff with byte.
		if(count%10 == 0):
			sys.stdout.write(".")
			#sys.stdout.write('0x%.2X count = %s\n' %(ord(byte), count))
		ser.write(byte)
		#sys.stdout.write('Byte transferred')

		waitcount = 0
		while ser.getCTS() == False:
			waitcount +=1
			if(waitcount%100000 == 0):
				print "waiting"
				
	sys.stdout.write("\nsent %s extra bytes overall\n" %count)		
    
def boot_kernel_sync():
    ''' Performs the initial autobaud detection as required by the UART boot mode '''

              
    print "Sending autobaud character to initiate UART boot Sequence\n"
    num_bytes = ser.write('@')
    checkvalue = ser.read()
    print "Check value of 0x%.2X received\n" %(ord(checkvalue))
    baudrate0 = ser.read()
    baudrate1 = ser.read()
    print "UART Clock rate of 0x%.8X received\n" %(ord(baudrate0) | (ord(baudrate1)<< 8))
    zeroval = ser.read()
    print "Zero value of 0x%.2X received\n" %(ord(zeroval))
    print "Autobaud detection phase completed successfully ... "
    
    
time.sleep(5)
boot_processor(_BOOT_FILE_NAME)


