/*********************************************************************************
Copyright(c) 2019 Analog Devices, Inc. All Rights Reserved.

This software is proprietary and confidential. By using this software you agree
to the terms of the associated Analog Devices License Agreement.
*********************************************************************************/

/*!
 * @file      main.c
 * @brief     Example to demonstrate LED blink in ADSP-21569 EZ-kit
 * @version:  $Revision: 37414 $
 * @date:     $Date: 2019-04-17 04:34:28 -0400 (Wed, 17 Apr 2019) $
 *
 * @details
 *            This is the primary source file to demonstrate
 *            LED 7/8/10 toggling in ADSP-21569 EZ-kit
 *
 */

/*=============  I N C L U D E S   =============*/
#include "main.h"

/*********************************************************************
*
*   Function:   main
*
*********************************************************************/
void main(int argc, char *argv[])
{
	adi_initComponents();
	ADI_GPIO_RESULT result,result1,result2,result3,result4;

	uint32_t gpioMaxCallbacks;
	/* Initialize the GPIO driver and allocate memory for callbacks*/
	Result = adi_gpio_Init((void*)gpioMemory,GPIO_MEMORY_SIZE,NULL);
	if(Result != ADI_GPIO_SUCCESS)
	{
		printf("GPIO Initialization failed \n");
	}

	/*Clear the data for output*/
	result1 = adi_gpio_Clear(ADI_GPIO_PORT_B,ADI_GPIO_PIN_3);
	if(result1 != ADI_GPIO_SUCCESS)
	{
		printf("GPIO Pin data set failed \n");
	}


	 /*Configure the Port Pin PB_03 as output for LED blink*/
	result4 = adi_gpio_SetDirection(ADI_GPIO_PORT_B,ADI_GPIO_PIN_3, ADI_GPIO_DIRECTION_OUTPUT);
	if(result4!= ADI_GPIO_SUCCESS)
	{
		printf("GPIO Initialization failed \n");
	}

	SRU(HIGH,DAI0_PBEN08_I);
	SRU(HIGH,DAI0_PBEN11_I);


	volatile int i=0;
	while(1)
	{
		/* Turn LED on */
		for(i=0;i<0x1000000;i++);
		SRU(HIGH,DAI0_PB08_I);
		SRU(HIGH,DAI0_PB11_I);
		adi_gpio_Toggle(ADI_GPIO_PORT_B,ADI_GPIO_PIN_3);
		asm("sync;");

		/* Turn LED off */
		for(i=0;i<0x1000000;i++);
		SRU(LOW,DAI0_PB08_I);
		SRU(LOW,DAI0_PB11_I);
		adi_gpio_Toggle(ADI_GPIO_PORT_B,ADI_GPIO_PIN_3);
		asm("sync;");
		for(i=0;i<0x1000000;i++);

	}




}

