/*****************************************************************************
 * SSL_Core0.c
 *****************************************************************************/

#include <sys/platform.h>
#include <sys/adi_core.h>
#include "adi_initialize.h"
#include "SSL_Core0.h"
#include "stdio.h"

#include <cdefSC59x_rom.h>
#include <defSC59x_rom.h>
#include<sru.h>

#define START_ADDRESS 0x60040000

int32_t ROM_BOOT_HOOK_FUNC1(ADI_ROM_BOOT_CONFIG * pBootConfig, ROM_HOOK_CALL_CAUSE cause);


int main(int argc, char *argv[])
{

	adi_initComponents();
/*
 * For SSL make sure that stack of the primary application does not coincide with that of secondary booting application.
 * One way to do this is to remap the stack of the primary application to Boot ROM stack space dynamically before calling the ROM API.
 * This is done in the following code snippet. Also cache is disabled for the 8KB region used by the ROM.
 * */

	/*SPI2 memory mapped boot*/
	
	uint32_t BootCmd=0;

	*pREG_SPU0_SECUREP146 = 0x3;
	*pREG_SPU0_SECUREP147 = 0x3;

	BootCmd = (2<<BITP_ROM_BCMD_DEVENUM)|(7<<BITP_ROM_BCMD_DEVICE); /*SPI2 master*/

	/*An hook routine can be used with adi_rom_Boot to customize the boot process*/
	adi_rom_Boot((unsigned int *)START_ADDRESS, BITM_ROM_BFLAG_HOOK,0, &ROM_BOOT_HOOK_FUNC1,BootCmd); /* ROM API is calling the Image stored in Sector 4 of the SPI flash */

	while(1);

}

int32_t ROM_BOOT_HOOK_FUNC1(ADI_ROM_BOOT_CONFIG * pBootConfig, ROM_HOOK_CALL_CAUSE cause)
{
	if (cause == ROM_HOOK_CALL_INIT_COMPLETE)
	{

	}
	if (cause == ROM_HOOK_CALL_CONFIG_COMPLETE)
	{
		/*Customization of boot process can be done here*/
		asm("NOP;");
	}

	return 0;
}

