/*****************************************************************************
 * CGU_Configuration_Core0.c
 *****************************************************************************/

#include <sys/platform.h>
#include "adi_initialize.h"
#include "CGU_Configuration_Core0.h"

#include <cdefSC59x_rom.h>
#include <defSC59x_rom.h>
#include <stdio.h>
#include <stdlib.h>

ADI_ROM_OTP_BOOT_CGU_INFO CGU_Config;


int main(int argc, char *argv[])
{

	   adi_initComponents();

	   CGU_Config.ctl_WEN=1;
	   CGU_Config.div_WEN=1;
	   CGU_Config.div_DSEL=3;/*1600/3=533*/
	   CGU_Config.div_CSEL=2;
	   CGU_Config.div_S0SEL=4;
	   CGU_Config.div_SYSSEL=4;
	   CGU_Config.div_S1SEL=2;
	   CGU_Config.div_OSEL=0x10;
	   CGU_Config.ctl_DF=0;
	   CGU_Config.ctl_MSEL=64;/*25*64 = 1600*/
	   CGU_Config.auto_disable=0; /* disable auto alignment*/;
	   CGU_Config.clkoutsel_CLKOUTSEL=0;
	   CGU_Config.clkoutsel_WEN=0;

	   CGU_Config.oscwctl0_WEN=1;
	   CGU_Config.oscwctl0_HODF=0;
	   CGU_Config.oscwctl0_HODEN=0;
	   CGU_Config.oscwctl0_CNGEN=0;
	   CGU_Config.oscwctl0_BOUF=0x1F;
	   CGU_Config.oscwctl0_BOUEN=1;
	   CGU_Config.oscwctl0_FAULTEN=1;
	   CGU_Config.oscwctl0_MONDIS=0;
	   CGU_Config.oscwctl0_FAULTPINDIS=1;

	   /*Perform CGU Initialization using adi_rom_CguInit*/
	   adi_rom_CguInit(&CGU_Config);

	   int CGU_MSEL_VALUE = (*pREG_CGU0_CTL & BITM_CGU_CTL_MSEL)>>BITP_CGU_CTL_MSEL;
	   int CGU_DSEL_VALUE = (*pREG_CGU0_DIV & BITM_CGU_DIV_DSEL)>>BITP_CGU_DIV_DSEL;

	   if((CGU_MSEL_VALUE == 64)&&(CGU_DSEL_VALUE == 3))
	   {
		   printf("Test Passed\n");
	   }
	   else
	   {
		   printf("Test Failed\n");
	   }

	   while(1);

}
