/*****************************************************************************
 * Return_Flag_Core1.c
 *****************************************************************************/

#include <sys/platform.h>
#include <sys/adi_core.h>
#include "adi_initialize.h"
#include "Return_Flag_Core1.h"

#include <cdefSC59x_rom.h>
#include <defSC59x_rom.h>

int main()
{

	adi_initComponents();
	/*
	 * For SSL make sure that stack of the primary application does not coincide with that of secondary booting application.
	 * One way to do this is to remap the stack of the primary application to Boot ROM stack space dynamically before calling the ROM API.
	 * This is done in the following code snippet. Also cache is disabled for the 8KB region used by the ROM.
	 * */
	*pREG_SHL1C0_CFG2|=0xF00 ;
	*pREG_SHL1C0_RANGE_START4 = 0x201FE000 ;
	*pREG_SHL1C0_RANGE_END4 = 0x201FFFFF ;

	asm("#include <sys/def215xx_core.h>");
	asm("IRPTL = 0;");
	asm("MMASK = BITM_REGF_MMASK_BR8|BITM_REGF_MMASK_BR0|BITM_REGF_MMASK_IRPTEN|BITM_REGF_MMASK_ALUSAT|BITM_REGF_MMASK_TRUNCATE|BITM_REGF_MMASK_PEYEN|BITM_REGF_MMASK_BDCST9|BITM_REGF_MMASK_BDCST1;");
	asm("IMASK = BITM_REGF_IMASK_EMUI|BITM_REGF_IMASK_RSTI|BITM_REGF_IMASK_PARI|BITM_REGF_IMASK_ILOPI|BITM_REGF_IMASK_CB7I|BITM_REGF_IMASK_IICDI|BITM_REGF_IMASK_SOVFI| BITM_REGF_IMASK_ILADI; nop;");
	asm("B7 = 0x201FF400;\
		             I7 = ((0x201FF400 + 0xc00 - 1)-((0x201FF400 + 0xc00 - 1) % 4) );\
	       L7 = (( 0xc00 - ((0x201FF400 + 0xc00 - 1) % 4) )/4);\
		      B6 = B7;\
		      I6 = I7; \
		      L6 = L7;");

	*pREG_SPU0_SECUREP146= 0x3; //MDMA0_SRC
	*pREG_SPU0_SECUREP147= 0x3; //MDMA0_DST

	adi_rom_Boot((unsigned int *)0x60040000,BITM_ROM_BFLAG_RETURN,0,0,0x10207);

	return 0;
}

