/*****************************************************************************
 * ROMAPI_Boot_Core1.c
 *****************************************************************************/


#include "CustomBootMode.h"



void ConfigSoftSwitches_EVAL_EZKIT_SOM(void);
void ConfigSoftSwitches_EV_SOM(void);

#include <cdefSC59x_rom.h>
#include <defSC59x_rom.h>


void bootInitFunction(ADI_ROM_BOOT_CONFIG * pBootConfig);
void bootConfigFunction(ADI_ROM_BOOT_CONFIG * pBootConfig);
void bootLoadFunction(ADI_ROM_BOOT_CONFIG * pBootConfig);
void bootCleanUpFunction(ADI_ROM_BOOT_CONFIG * pBootConfig);


int32_t ROM_BOOT_HOOK_FUNC1(ADI_ROM_BOOT_CONFIG * pBootConfig, ROM_HOOK_CALL_CAUSE cause) ;
ADI_ROM_OTP_BOOT_CGU_INFO cgu_config;
ADI_ROM_OTP_DMC_CONFIG dmc_config;

bool Result;
ADI_ROM_BOOT_CONFIG * pBootConfig_Temp;

/** 
 * If you want to use command program arguments, then place them in the following string. 
 */
char __argv_string[] = "";

int main(int argc, char *argv[])
{
	adi_initComponents();

	*pREG_SHL1C0_CFG2|=0xF00 ;
	*pREG_SHL1C0_RANGE_START4 = 0x201FE000 ;
	*pREG_SHL1C0_RANGE_END4 = 0x201FFFFF ;

	asm("#include <sys/def215xx_core.h>");
	asm("IRPTL = 0;");
	asm("MMASK = BITM_REGF_MMASK_BR8|BITM_REGF_MMASK_BR0|BITM_REGF_MMASK_IRPTEN|BITM_REGF_MMASK_ALUSAT|BITM_REGF_MMASK_TRUNCATE|BITM_REGF_MMASK_PEYEN|BITM_REGF_MMASK_BDCST9|BITM_REGF_MMASK_BDCST1;");
	asm("IMASK = BITM_REGF_IMASK_EMUI|BITM_REGF_IMASK_RSTI|BITM_REGF_IMASK_PARI|BITM_REGF_IMASK_ILOPI|BITM_REGF_IMASK_CB7I|BITM_REGF_IMASK_IICDI|BITM_REGF_IMASK_SOVFI| BITM_REGF_IMASK_ILADI; nop;");
	asm("B7 = 0x201FF400;\
	              I7 = ((0x201FF400 + 0xc00 - 1)-((0x201FF400 + 0xc00 - 1) % 4) );\
	       L7 = (( 0xc00 - ((0x201FF400 + 0xc00 - 1) % 4) )/4);\
	       B6 = B7;\
	       I6 = I7; \
	        L6 = L7;");

	/* Select the macronix flash on Carrier board*/
	ConfigSoftSwitches_EVAL_EZKIT_SOM();
	/* De-select the issi flash on SOM board*/
	ConfigSoftSwitches_EV_SOM();

    uint32_t BootCmd=0;


	*pREG_SPU0_SECUREP147 = 0x3;
	*pREG_SPU0_SECUREP148 = 0x3;



	BootCmd = (0xF<<BITP_ROM_BCMD_SPIM_DEVICE); /*Custom Boot Support*/
	adi_rom_Boot((void *)START_ADDRESS, BITM_ROM_BFLAG_HOOK, 0, &ROM_BOOT_HOOK_FUNC1,BootCmd);

	while(1);

}

int32_t ROM_BOOT_HOOK_FUNC1(ADI_ROM_BOOT_CONFIG * pBootConfig, ROM_HOOK_CALL_CAUSE cause)
{
	if (cause == ROM_HOOK_REG_COMPLETE)
	{
		pBootConfig->bootRegistry.pInitFunction = (ROM_BOOT_MODE_INIT_FUNC  *)bootInitFunction;
		pBootConfig->bootRegistry.pConfigFunction = (ROM_BOOT_MODE_CONFIG_FUNC *)bootConfigFunction;
		pBootConfig->bootRegistry.pLoadFunction = (ROM_BOOT_MODE_LOAD_FUNC *)bootLoadFunction;
		pBootConfig->bootRegistry.pCleanUpFunction = (ROM_BOOT_MODE_CLEANUP_FUNC  *)bootCleanUpFunction;

		asm("NOP;");
	}
	if (cause == ROM_HOOK_CALL_INIT_COMPLETE)
	{
		asm("NOP;");
	}
	if (cause == ROM_HOOK_CALL_CONFIG_COMPLETE)
	{
		asm("NOP;");
	}

	return 0;
}

