/*****************************************************************************
 * ROMAPI_Boot_Core1.c
 *****************************************************************************/


#include "CustomBootMode.h"



void ConfigSoftSwitches_EVAL_EZKIT_SOM(void);
void ConfigSoftSwitches_EV_SOM(void);

#include <cdefSC59x_rom.h>
#include <defSC59x_rom.h>


void bootInitFunction(ADI_ROM_BOOT_CONFIG * pBootConfig);
void bootConfigFunction(ADI_ROM_BOOT_CONFIG * pBootConfig);
void bootLoadFunction(ADI_ROM_BOOT_CONFIG * pBootConfig);
void bootCleanUpFunction(ADI_ROM_BOOT_CONFIG * pBootConfig);


int32_t ROM_BOOT_HOOK_FUNC1(ADI_ROM_BOOT_CONFIG * pBootConfig, ROM_HOOK_CALL_CAUSE cause) ;
ADI_ROM_OTP_BOOT_CGU_INFO cgu_config;
ADI_ROM_OTP_DMC_CONFIG dmc_config;

bool Result;
ADI_ROM_BOOT_CONFIG * pBootConfig_Temp;

/** 
 * If you want to use command program arguments, then place them in the following string. 
 */
char __argv_string[] = "";

int main(int argc, char *argv[])
{
	adi_initComponents();

	/* Select the macronix flash on Carrier board*/
	ConfigSoftSwitches_EVAL_EZKIT_SOM();
	/* De-select the issi flash on SOM board*/
	ConfigSoftSwitches_EV_SOM();

    uint32_t BootCmd=0;


	*pREG_SPU0_SECUREP147 = 0x3;
	*pREG_SPU0_SECUREP148 = 0x3;



	BootCmd = (0xF<<BITP_ROM_BCMD_SPIM_DEVICE); /*Custom Boot Support*/
	adi_rom_Boot((void *)START_ADDRESS, BITM_ROM_BFLAG_HOOK, 0, &ROM_BOOT_HOOK_FUNC1,BootCmd);

	while(1);

}

int32_t ROM_BOOT_HOOK_FUNC1(ADI_ROM_BOOT_CONFIG * pBootConfig, ROM_HOOK_CALL_CAUSE cause)
{
	if (cause == ROM_HOOK_REG_COMPLETE)
	{
		pBootConfig->bootRegistry.pInitFunction = (ROM_BOOT_MODE_INIT_FUNC  *)bootInitFunction;
		pBootConfig->bootRegistry.pConfigFunction = (ROM_BOOT_MODE_CONFIG_FUNC *)bootConfigFunction;
		pBootConfig->bootRegistry.pLoadFunction = (ROM_BOOT_MODE_LOAD_FUNC *)bootLoadFunction;
		pBootConfig->bootRegistry.pCleanUpFunction = (ROM_BOOT_MODE_CLEANUP_FUNC  *)bootCleanUpFunction;

		asm("NOP;");
	}
	if (cause == ROM_HOOK_CALL_INIT_COMPLETE)
	{
		asm("NOP;");
	}
	if (cause == ROM_HOOK_CALL_CONFIG_COMPLETE)
	{
		asm("NOP;");
	}

	return 0;
}

