#include <cdefSC59x_rom.h>
#include <defSC59x_rom.h>


#include "ospi_flashdirectaccess_octal.h"

/* Buffer for use in STIG mode */
uint8_t STIG_RW_Buffer[8];

extern ADI_OSPI_STIGCMD STIG_Command;

ROM_BOOT_RESULT bootInitFunction(ADI_ROM_BOOT_CONFIG * pBootConfig)
{
	ROM_BOOT_RESULT result;
    *pREG_SCB5_REMAP = 0x1;            /* Remap the AXI accesses to SPI3 */
    return ROM_BOOT_SUCCESS;

}


ROM_BOOT_RESULT bootConfigFunction(ADI_ROM_BOOT_CONFIG * pBootConfig)
{
	/*Do pin mux*/
    /*Configure pinmux to enable octal mode */
	*pREG_PORTA_MUX = 0xAA555;
	*pREG_PORTA_FER = (BITM_PORT_FER_PX0 |BITM_PORT_FER_PX1| BITM_PORT_FER_PX2 | BITM_PORT_FER_PX3 | BITM_PORT_FER_PX4| BITM_PORT_FER_PX5 |
					   BITM_PORT_FER_PX6 | BITM_PORT_FER_PX7 | BITM_PORT_FER_PX8 | BITM_PORT_FER_PX9 );

	/*OSPI Single Mode Config*/
	*pREG_OSPI0_CTL=0x80783881;
	*pREG_OSPI0_DRICTL = 0x03;
	*pREG_OSPI0_DSCTL = 0x02;
	*pREG_OSPI0_DWICTL = 0x02;
	*pREG_OSPI0_FCA = 0;
	*pREG_OSPI0_MBCTL = 0x0;
	*pREG_OSPI0_OE_LWR = 0x13EDFA00;
	*pREG_OSPI0_OE_UP = 0x06F90000;
	*pREG_OSPI0_POLLEXP = 0XFFFFFFFF;
	*pREG_OSPI0_RDC = 0X1003F;
	*pREG_OSPI0_WCCTL = 0X10005;



	Configure_Flash(&STIG_Command); /* Configure the macronix flash for ocatal mode */

	Configure_Octal(); /* configure the OSPI controller for ocatl mode */


	/*Update the boot type as non-secure boot - This is required to be done in config routine*/
	pBootConfig->bootType = ADI_ROM_SECURE_BOOT_DIS;

	return ROM_BOOT_SUCCESS;
}

void bootLoadFunction(ADI_ROM_BOOT_CONFIG * pBootConfig)
{

	ROM_BOOT_RESULT result;

	  ROM_DMA_MDMA_CONFIG MdmaCfg;
	  MdmaCfg.pSource = pBootConfig->pSource;
	  MdmaCfg.pDestination = pBootConfig->pDestination;
	  MdmaCfg.ByteCount = pBootConfig->dByteCount;
	  MdmaCfg.eId = ROM_DMA_MDMA0;
	  MdmaCfg.eOperation = ROM_DMA_MEM_COPY;
	  MdmaCfg.eDoneDetect = pBootConfig->loadType;

	  result = adi_rom_MemDma(&MdmaCfg);

	  /* Update pSource pointer */
	  pBootConfig->pSource = (void *) ((uint32_t) pBootConfig->pSource + (pBootConfig->uwSrcModifyMult * pBootConfig->dByteCount));

}

ROM_BOOT_RESULT bootCleanUpFunction(ADI_ROM_BOOT_CONFIG * pBootConfig)
{
	asm("NOP;");
	return ROM_BOOT_SUCCESS;
}

