#include "OTP_GP_Space_Programmming.h"

/*Comment out the below macro to program the OTP space for GP1*/
//#define Program_OTP

bool bResult;
otp_data sMy_OTP_data;

/*value to be programmed */
uint32_t uiOTP_GP1[ROM_OTP_SZ_gp1]={0x12345678};
/* to be read */
uint32_t uiOTP_GP1_Read1[ROM_OTP_SZ_gp1]={0xAAAAAAAA};
/* variables to compare the program value */
uint32_t uiOTP_GP1_Read2[ROM_OTP_SZ_gp1]={0xAAAAAAAA};

int main(void)
{

	adi_initComponents();
	/* Disable the cache for OTP region only through RANGE register */
    *pREG_SHL1C0_CFG2 =0x30;
    *pREG_SHL1C0_RANGE_START2 = 0x24000000 ;
    *pREG_SHL1C0_RANGE_END2 = 0x24001FFF ;

    /* Read the OTP space before programming it */
	bResult = adi_rom_otp_get(otpcmd_gp1, uiOTP_GP1_Read1);
	if(bResult==true)
	{
		printf("\n GP1 read is successful \n");
		sMy_OTP_data.gp1 = &uiOTP_GP1;
		int i=0;
		for(i=0;i<ROM_OTP_SZ_gp1;i++)
		{
			if(uiOTP_GP1_Read1[i] !=0)
			{
				printf("\n GP1 Space is already programmed \n");
				return 0;

			}
		}
#ifdef Program_OTP
		bResult = adi_rom_otp_pgm(&sMy_OTP_data);
#endif
		if(bResult==true)
		{
			printf("\n GP1 programmed successfully \n");
			/* Read the OTP space after programming it and compare*/
			bResult = adi_rom_otp_get(otpcmd_gp1, uiOTP_GP1_Read2);
			if(bResult==true)
			{
				printf("\n GP1 read after programming is successful \n");

				for(i=0;i<ROM_OTP_SZ_gp1;i++)
				{
					if(uiOTP_GP1[i]!=uiOTP_GP1_Read2[i])
					{
						printf("\n Data in OTP is not programmed successfully at offset %d \n",i);
					}
					else
					{
						printf("\n Data in OTP programmed successfully at offset %d \n", i);
					}
				}
			}

		}
	}

	return 0;

}

